package SearchTrees;

public class TestSearchTree {

	public static void main(String[] args) {
		SearchTree tree = new SearchTree();
		for (int i=0; i<100; ++i)
		{
			int ran = (int)(Math.random()*1000);
			tree.Delete(ran);
			tree.Insert(ran);
			System.out.println(i+". insert "+ran);
			assert(tree.HasKey(ran));
			ran = (int)(Math.random()*1000);
			if (tree.Delete(ran)) 
				System.out.println("deleted "+ran);
			else
				System.out.println("not present "+ran);
				
			assert(!tree.HasKey(ran));
			if (tree.HasKey(ran)) System.err.println("error Delete");
			tree.Insert(ran);
		}
		tree.print();
		System.out.println("tree depth "+tree.GetDepth());
		
		System.out.println("Now testing search");
		Boolean fail = false;
		for (int i=0; i<100; ++i)
		{
			int ran = (int)(Math.random()*1000);
			tree.Delete(ran);
			tree.Insert(ran);
			SearchNode regular_search = tree.Search(ran);
			SearchNode recursive_search = tree.SearchRecursive(ran);
			if (regular_search != recursive_search){
				fail = true;
			}			
				
		}
		if (fail)
			System.out.println("Your recursive Search yields different results then the looped version");
		else
			System.out.println("Test successful");
		
	}

}
